//+------------------------------------------------------------------+
//|                                                        iUSDx.mq5 |
//|                                            Copyright 2010, Lizar |
//|                            https://login.mql5.com/ru/users/Lizar |
//+------------------------------------------------------------------+
#define VERSION       "1.00 Build 1 (17 Dec 2010)"

#property copyright   "Copyright 2010, Lizar"
#property link        "https://login.mql5.com/ru/users/Lizar"
#property version     VERSION
#property description "  \" \" iUSDx."
#property description "         : EUR, JPY, GBP, CAD, SEK  CHF." 
#property description "        \"Control panel MCM\""

//----  :
#property indicator_separate_window        //     
#property indicator_plots 1                //  1  :
#property indicator_buffers 7              //  8 
//    - :
#property indicator_type1  DRAW_LINE      //     -  
#property indicator_color1 Red             //     
#property indicator_width1 2               //      " "

#include <Control panel MCM.mqh> //<---   Control panel MCM
#include "iUSDx.mqh"

input int count=500; //    

double iUSDx_Ind[];

string   currency="USD"; // 
int      symbol_total=6; //      
int      calculate=0;

CUSDx *buffer[];
stCurrencyWeight currency_weight[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   //---  Control panel MCA. 
   InitControlPanelMCM();

   ArrayResize(buffer,symbol_total);
   ArrayResize(currency_weight,symbol_total);
   
   currency_weight[0].symbol ="EURUSD"; currency_weight[0].weight =0.576;
   currency_weight[1].symbol ="USDJPY"; currency_weight[1].weight =0.136;
   currency_weight[2].symbol ="GBPUSD"; currency_weight[2].weight =0.119;
   currency_weight[3].symbol ="USDCAD"; currency_weight[3].weight =0.091;
   currency_weight[4].symbol ="USDSEK"; currency_weight[4].weight =0.042;
   currency_weight[5].symbol ="USDCHF"; currency_weight[5].weight =0.036;

   //--- indicator buffers mapping
   SetIndexBuffer(0,iUSDx_Ind,INDICATOR_DATA);          //  iUSDx_Ind[]   

   for(int i=0; i<symbol_total; i++)
     {
      buffer[i]=new CUSDx;
      SetIndexBuffer(i+1,buffer[i].buffer,INDICATOR_CALCULATIONS); //     i- 
      buffer[i].SetCurrencyAndWeight(currency_weight[i].symbol, currency_weight[i].weight);
     }

   ArraySetAsSeries(iUSDx_Ind,true);  //    iUSDx_Ind[]     

   //--- set accuracy
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
   
   //--- name for DataWindow and indicator subwindow label
   IndicatorSetString(INDICATOR_SHORTNAME,"iUSDx "+VERSION);
   PlotIndexSetString(0,PLOT_LABEL,"iUSDx");
   return(0);
  }

//+------------------------------------------------------------------+
//|    .     |
//|    ,    .        |
//|                                                                  |
//|   Control panel MCM            |
//|  .                                         |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,         //       " "+CHARTEVENT_CUSTOM  
                  const long& lparam,   //  
                  const double& dparam, // 
                  const string& sparam  //  
                 )
  {
   int custom_id=id-CHARTEVENT_CUSTOM-1;
   
   if(custom_id>=0)      
     {
        if(lparam!=CHARTEVENT_NEWBAR_NO)
        {
         if(EventToPeriod(lparam)==_Period && sparam==_Symbol)
           { //         
            iUSDx_Ind[0]=EMPTY_VALUE;
            for(int i=0;i<symbol_total;i++) buffer[i].USDxSymbol();
            iUSDx(symbol_total);
            return;
           }
         
         buffer[custom_id].USDxSymbol();
         iUSDx(symbol_total);
         return;
        }
      else 
        { //     "" 
         buffer[custom_id].InitSymbol(count,currency,sparam);
         Init_iUSDx(symbol_total,calculate);
         return;
        }
     }
  }
   
//+------------------------------------------------------------------+
//|                           |
//| INPUT:  total       - r    ;     |
//|         count_iUSDx -    .              |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void Init_iUSDx(int total, int count_iUSDx)
  {   
   for(int bar=count_iUSDx-1; bar>=0; bar--) iUSDx(total,bar);     
   return;
  }

//+------------------------------------------------------------------+
//|               |
//| INPUT:  total  - r    ;          |
//|         bar    -    .                         |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void iUSDx(int total, int bar=0)
  {
   iUSDx_Ind[bar]=50.14348112;
   for(int i=0;i<total;i++) 
     if(buffer[i].buffer[bar]!=EMPTY_VALUE && buffer[i].GetInit()) iUSDx_Ind[bar]*=buffer[i].buffer[bar];
     else { iUSDx_Ind[bar]=EMPTY_VALUE; return; }   
   if(iUSDx_Ind[bar]<5) iUSDx_Ind[bar]=EMPTY_VALUE;
   return;
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total, const int prev_calculated, const int begin, const double &price[]) 
  {
   if(prev_calculated==0)
     {
      ArrayInitialize(iUSDx_Ind,EMPTY_VALUE); 
      calculate=MathMin(rates_total,TerminalInfoInteger(TERMINAL_MAXBARS));   
      calculate=MathMin(calculate,count);
     }

   return(rates_total);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   for(int i=0;i<symbol_total;i++) delete buffer[i];   
   DeinitControlPanelMCM();   //<---  Control panel MCA:
  }
//+------------------------------------------------------------------+
